Index: /trunk/SophyaLib/Samba/spheregorski.cc
===================================================================
--- /trunk/SophyaLib/Samba/spheregorski.cc	(revision 469)
+++ /trunk/SophyaLib/Samba/spheregorski.cc	(revision 470)
@@ -898,58 +871,18 @@
   iy_low = (int)fmod(iy,128);
   iy_hi  = iy/128;
-  ipf =  (x2pix_[ix_hi]+y2pix_[iy_hi]) * (128 * 128)
-    + (x2pix_[ix_low]+y2pix_[iy_low]);
+  ipf=(PXY.x2pix_(ix_hi)+PXY.y2pix_(iy_hi))*(128*128)+(PXY.x2pix_(ix_low)+PXY.y2pix_(iy_low));
 
   return (ipf + face_num* nside *nside);//   ! in {0, 12*nside**2 - 1}
 }
 
-void SphereGorski::mk_xy2pix(int *x2pix, int *y2pix) {
+template<class T>
+int SphereGorski<T>::ang2pix_ring(int nside, double theta, double phi) const 
+{
   /*
-    c=======================================================================
-    subroutine mk_xy2pix
-    c=======================================================================
-    c     sets the array giving the number of the pixel lying in (x,y)
-    c     x and y are in {1,128}
-    c     the pixel number is in {0,128**2-1}
-    c
-    c     if  i-1 = sum_p=0  b_p * 2^p
-    c     then ix = sum_p=0  b_p * 4^p
-    c          iy = 2*ix
-    c     ix + iy in {0, 128**2 -1}
-    c=======================================================================
-  */
-  // tranlated from FORTRAN (Gorski) to C, by B. Revenu, revised Guy Le Meur
-  //  (16/12/98)
-
-  int K,IP,I,J,ID;
-
-  for( int i(0);i<127;i++ ) x2pix[i]=0;
-  for( I=1;I<=128;I++ ) {
-    J  = I-1;//            !pixel numbers
-    K  = 0;//
-    IP = 1;//
-    truc : if( J==0 ) {
-      x2pix[I-1] = K;
-      y2pix[I-1] = 2*K;
-    }
-    else {
-      ID = (int)fmod(J,2);
-      J  = J/2;
-      K  = IP*ID+K;
-      IP = IP*4;
-      goto truc;
-    }
-  }     
-  //c      endif
-  
-}
-
-int SphereGorski::ang2pix_ring(int nside, double theta, double phi) const {
-    /*
-    c=======================================================================
+    ==================================================
     c     gives the pixel number ipix (RING) 
     c     corresponding to angles theta and phi
-    c=======================================================================
-  */
+    c==================================================
+    */
   // tranlated from FORTRAN (Gorski) to C, by B. Revenu, revised Guy Le Meur
   //  (16/12/98)
@@ -1017,12 +950,13 @@
   }
     return (ipix1 - 1);// ! in {0, npix-1}
-  
-}
-
-int SphereGorski::ang2pix_nest(int nside, double theta, double phi) const {
+}
+
+template<class T>
+int SphereGorski<T>::ang2pix_nest(int nside, double theta, double phi) const 
+{
   /*
-    c=======================================================================
+    ==================================================
     subroutine ang2pix_nest(nside, theta, phi, ipix)
-    c=======================================================================
+    ==================================================
     c     gives the pixel number ipix (NESTED) 
     c     corresponding to angles theta and phi
@@ -1033,89 +967,91 @@
     c     that the treatement of round-off will be consistent 
     c     for every resolution
-    c=======================================================================
-  */
+    ==================================================
+    */
   // tranlated from FORTRAN (Gorski) to C, by B. Revenu, revised Guy Le Meur
   //  (16/12/98)
-    
-      double    z, za, z0, tt, tp, tmp;
-      int face_num,jp,jm;
-      int ifp, ifm;
-      int  ix, iy, ix_low, ix_hi, iy_low, iy_hi, ipf, ntt;
-      double piover2(Pi/2.), twopi(2.*Pi);
-      int ns_max(8192);
-
-      if( nside<1 || nside>ns_max ) {
-	cout << "nside out of range" << endl;
-	exit(0);
-      }
-      if( theta<0 || theta>Pi ) {
-	cout << "theta out of range" << endl;
-	exit(0);
-      }
-      z  = cos(theta);
-      za = fabs(z);
-      z0 = 2./3.;
-      if( phi>=twopi ) phi = phi - twopi;
-      if( phi<0. )    phi = phi + twopi;
-      tt = phi / piover2;// ! in [0,4[
-      if( za<=z0 ) { // then ! equatorial region
-	
-	//(the index of edge lines increase when the longitude=phi goes up)
-	jp = (int)floor(ns_max*(0.5 + tt - z*0.75));// !  ascending edge line index
-	jm = (int)floor(ns_max*(0.5 + tt + z*0.75));// ! descending edge line index
-
-	//c        finds the face
-	ifp = jp / ns_max;//  ! in {0,4}
-	ifm = jm / ns_max;
-        if( ifp==ifm ) face_num = (int)fmod(ifp,4) + 4; //then          ! faces 4 to 7
-	else if( ifp<ifm ) face_num = (int)fmod(ifp,4); // (half-)faces 0 to 3
-	else face_num = (int)fmod(ifm,4) + 8;//! (half-)faces 8 to 11
-
-	ix = (int)fmod(jm, ns_max);
-	iy = ns_max - (int)fmod(jp, ns_max) - 1;
-      }
-      else { //! polar region, za > 2/3
-	     
-	ntt = (int)floor(tt);
-	if( ntt>=4 ) ntt = 3;
-	tp = tt - ntt;
-	tmp = sqrt( 3.*(1. - za) );//  ! in ]0,1]
-
-	//(the index of edge lines increase when distance from the closest pole goes up)
-	jp = (int)floor( ns_max * tp          * tmp );// ! line going toward the pole as phi increases
-	jm = (int)floor( ns_max * (1. - tp) * tmp );// ! that one goes away of the closest pole
-	jp = (int)min(ns_max-1, jp);// ! for points too close to the boundary
-	jm = (int)min(ns_max-1, jm);
-
-	 // finds the face and pixel's (x,y)
-         if( z>=0 ) {
-	   face_num = ntt;//  ! in {0,3}
-            ix = ns_max - jm - 1;
-            iy = ns_max - jp - 1;
-	 }
-         else {
-	   face_num = ntt + 8;// ! in {8,11}
-            ix =  jp;
-            iy =  jm;
-	 }
-      }
-
-      ix_low = (int)fmod(ix,128);
-      ix_hi  =     ix/128;
-      iy_low = (int)fmod(iy,128);
-      iy_hi  =     iy/128;
-      ipf =  (x2pix_[ix_hi]+y2pix_[iy_hi]) * (128 * 128)+ (x2pix_[ix_low]+y2pix_[iy_low]);
-      ipf = ipf / pow(ns_max/nside,2);//  ! in {0, nside**2 - 1}
-      return ( ipf + face_num*pow(nside,2));//    ! in {0, 12*nside**2 - 1}
-}
-
-
-void SphereGorski::pix2ang_ring(int nside, int ipix, double& theta,  double& phi) const {
+  
+  const PIXELS_XY& PXY= PIXELS_XY::instance();
+
+  double    z, za, z0, tt, tp, tmp;
+  int face_num,jp,jm;
+  int ifp, ifm;
+  int  ix, iy, ix_low, ix_hi, iy_low, iy_hi, ipf, ntt;
+  double piover2(Pi/2.), twopi(2.*Pi);
+  int ns_max(8192);
+  
+  if( nside<1 || nside>ns_max ) {
+    cout << "nside out of range" << endl;
+    exit(0);
+  }
+  if( theta<0 || theta>Pi ) {
+    cout << "theta out of range" << endl;
+    exit(0);
+  }
+  z  = cos(theta);
+  za = fabs(z);
+  z0 = 2./3.;
+  if( phi>=twopi ) phi = phi - twopi;
+  if( phi<0. )    phi = phi + twopi;
+  tt = phi / piover2;// ! in [0,4[
+  if( za<=z0 ) { // then ! equatorial region
+    
+    //(the index of edge lines increase when the longitude=phi goes up)
+    jp = (int)floor(ns_max*(0.5 + tt - z*0.75));// !  ascending edge line index
+    jm = (int)floor(ns_max*(0.5 + tt + z*0.75));// ! descending edge line index
+    
+    //c        finds the face
+    ifp = jp / ns_max;//  ! in {0,4}
+    ifm = jm / ns_max;
+    if( ifp==ifm ) face_num = (int)fmod(ifp,4) + 4; //then          ! faces 4 to 7
+    else if( ifp<ifm ) face_num = (int)fmod(ifp,4); // (half-)faces 0 to 3
+    else face_num = (int)fmod(ifm,4) + 8;//! (half-)faces 8 to 11
+    
+    ix = (int)fmod(jm, ns_max);
+    iy = ns_max - (int)fmod(jp, ns_max) - 1;
+  }
+  else { //! polar region, za > 2/3
+    
+    ntt = (int)floor(tt);
+    if( ntt>=4 ) ntt = 3;
+    tp = tt - ntt;
+    tmp = sqrt( 3.*(1. - za) );//  ! in ]0,1]
+    
+    //(the index of edge lines increase when distance from the closest pole goes up)
+    jp = (int)floor(ns_max*tp*tmp); // ! line going toward the pole as phi increases
+    jm = (int)floor(ns_max*(1.-tp)*tmp); // ! that one goes away of the closest pole
+    jp = (int)min(ns_max-1, jp);// ! for points too close to the boundary
+    jm = (int)min(ns_max-1, jm);
+    
+    // finds the face and pixel's (x,y)
+    if( z>=0 ) {
+      face_num = ntt;//  ! in {0,3}
+      ix = ns_max - jm - 1;
+      iy = ns_max - jp - 1;
+    }
+    else {
+      face_num = ntt + 8;// ! in {8,11}
+      ix =  jp;
+      iy =  jm;
+    }
+  }
+  
+  ix_low = (int)fmod(ix,128);
+  ix_hi  =     ix/128;
+  iy_low = (int)fmod(iy,128);
+  iy_hi  =     iy/128;
+  ipf= (PXY.x2pix_(ix_hi)+PXY.y2pix_(iy_hi))*(128*128)+(PXY.x2pix_(ix_low)+PXY.y2pix_(iy_low));
+  ipf = ipf / pow(ns_max/nside,2);//  ! in {0, nside**2 - 1}
+  return ( ipf + face_num*pow(nside,2));//    ! in {0, 12*nside**2 - 1}
+}
+
+template<class T>
+void SphereGorski<T>::pix2ang_ring(int nside,int ipix,double& theta,double& phi) const {
   /*
-    c=======================================================================
+    ===================================================
     c     gives theta and phi corresponding to pixel ipix (RING) 
     c     for a parameter nside
-    c=======================================================================
-  */
+    ===================================================
+    */
   // tranlated from FORTRAN (Gorski) to C, by B. Revenu, revised Guy Le Meur
   //  (16/12/98)
@@ -1178,183 +1114,338 @@
 }
 
-void SphereGorski::pix2ang_nest(int nside, int ipix, double& theta, double& phi) const {
+template<class T>
+void SphereGorski<T>::pix2ang_nest(int nside,int ipix,double& theta,double& phi) const {
   /*
-    c=======================================================================
+    ==================================================
     subroutine pix2ang_nest(nside, ipix, theta, phi)
-    c=======================================================================
+    ==================================================
     c     gives theta and phi corresponding to pixel ipix (NESTED) 
     c     for a parameter nside
-    c=======================================================================
-  */
+    ==================================================
+    */
   // tranlated from FORTRAN (Gorski) to C, by B. Revenu, revised Guy Le Meur
   //  (16/12/98)
-    
-      int npix, npface, face_num;
-      int  ipf, ip_low, ip_trunc, ip_med, ip_hi;
-      int     ix, iy, jrt, jr, nr, jpt, jp, kshift, nl4;
-      double z, fn, fact1, fact2;
-      double piover2(Pi/2.);
-      int ns_max(8192);
-      
-      
-      // ! coordinate of the lowest corner of each face
-      int jrll[12]={2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4};//! in unit of nside
-      int jpll[12]={1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7};// ! in unit of nside/2
-      
-      if( nside<1 || nside>ns_max ) {
-	cout << "nside out of range" << endl;
-	exit(0);
-      }
-      npix = 12 * nside*nside;
-      if( ipix<0 || ipix>npix-1 ) {
-	cout << "ipix out of range" << endl;
-	exit(0);
-      }
-
-      fn = 1.*nside;
-      fact1 = 1./(3.*fn*fn);
-      fact2 = 2./(3.*fn);
-      nl4   = 4*nside;
-
-      //c     finds the face, and the number in the face
-      npface = nside*nside;
-
-      face_num = ipix/npface;//  ! face number in {0,11}
-      ipf = (int)fmod(ipix,npface);//  ! pixel number in the face {0,npface-1}
-
-      //c     finds the x,y on the face (starting from the lowest corner)
-      //c     from the pixel number
-      ip_low = (int)fmod(ipf,1024);//       ! content of the last 10 bits
-      ip_trunc =   ipf/1024 ;//       ! truncation of the last 10 bits
-      ip_med = (int)fmod(ip_trunc,1024);//  ! content of the next 10 bits
-      ip_hi  =     ip_trunc/1024   ;//! content of the high weight 10 bits
-
-      ix = 1024*pix2x_[ip_hi] + 32*pix2x_[ip_med] + pix2x_[ip_low];
-      iy = 1024*pix2y_[ip_hi] + 32*pix2y_[ip_med] + pix2y_[ip_low];
-
-      //c     transforms this in (horizontal, vertical) coordinates
-      jrt = ix + iy;//  ! 'vertical' in {0,2*(nside-1)}
-      jpt = ix - iy;//  ! 'horizontal' in {-nside+1,nside-1}
-
-      //c     computes the z coordinate on the sphere
-      //      jr =  jrll[face_num+1]*nside - jrt - 1;//   ! ring number in {1,4*nside-1}
-      jr =  jrll[face_num]*nside - jrt - 1;
-      nr = nside;//                  ! equatorial region (the most frequent)
-      z  = (2*nside-jr)*fact2;
-      kshift = (int)fmod(jr - nside, 2);
-      if( jr<nside ) { //then     ! north pole region
-         nr = jr;
-         z = 1. - nr*nr*fact1;
-         kshift = 0;
-      }
-      else {
-	if( jr>3*nside ) {// then ! south pole region
-         nr = nl4 - jr;
-         z = - 1. + nr*nr*fact1;
-         kshift = 0;
+
+  const PIXELS_XY& PXY= PIXELS_XY::instance();
+    
+  int npix, npface, face_num;
+  int ipf, ip_low, ip_trunc, ip_med, ip_hi;
+  int ix, iy, jrt, jr, nr, jpt, jp, kshift, nl4;
+  double z, fn, fact1, fact2;
+  double piover2(Pi/2.);
+  int ns_max(8192);
+          
+  // ! coordinate of the lowest corner of each face
+  int jrll[12]={2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4};//! in unit of nside
+  int jpll[12]={1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7};// ! in unit of nside/2
+  
+  if( nside<1 || nside>ns_max ) {
+    cout << "nside out of range" << endl;
+    exit(0);
+  }
+  npix = 12 * nside*nside;
+  if( ipix<0 || ipix>npix-1 ) {
+    cout << "ipix out of range" << endl;
+    exit(0);
+  }
+  
+  fn = 1.*nside;
+  fact1 = 1./(3.*fn*fn);
+  fact2 = 2./(3.*fn);
+  nl4   = 4*nside;
+
+  //c     finds the face, and the number in the face
+  npface = nside*nside;
+  
+  face_num = ipix/npface;//  ! face number in {0,11}
+  ipf = (int)fmod(ipix,npface);//  ! pixel number in the face {0,npface-1}
+  
+  //c     finds the x,y on the face (starting from the lowest corner)
+  //c     from the pixel number
+  ip_low = (int)fmod(ipf,1024);//       ! content of the last 10 bits
+  ip_trunc =   ipf/1024 ;//       ! truncation of the last 10 bits
+  ip_med = (int)fmod(ip_trunc,1024);//  ! content of the next 10 bits
+  ip_hi  =     ip_trunc/1024   ;//! content of the high weight 10 bits
+  
+  ix = 1024*PXY.pix2x_(ip_hi)+32*PXY.pix2x_(ip_med)+PXY.pix2x_(ip_low);
+  iy = 1024*PXY.pix2y_(ip_hi)+32*PXY.pix2y_(ip_med)+PXY.pix2y_(ip_low);
+  
+  //c     transforms this in (horizontal, vertical) coordinates
+  jrt = ix + iy;//  ! 'vertical' in {0,2*(nside-1)}
+  jpt = ix - iy;//  ! 'horizontal' in {-nside+1,nside-1}
+  
+  //c     computes the z coordinate on the sphere
+  //      jr =  jrll[face_num+1]*nside - jrt - 1;//   ! ring number in {1,4*nside-1}
+  jr =  jrll[face_num]*nside - jrt - 1;
+  nr = nside;//                  ! equatorial region (the most frequent)
+  z  = (2*nside-jr)*fact2;
+  kshift = (int)fmod(jr - nside, 2);
+  if( jr<nside ) { //then     ! north pole region
+    nr = jr;
+    z = 1. - nr*nr*fact1;
+    kshift = 0;
+  }
+  else {
+    if( jr>3*nside ) {// then ! south pole region
+      nr = nl4 - jr;
+      z = - 1. + nr*nr*fact1;
+      kshift = 0;
+    }
+  }
+  theta = acos(z);
+  
+  //c     computes the phi coordinate on the sphere, in [0,2Pi]
+  //      jp = (jpll[face_num+1]*nr + jpt + 1 + kshift)/2;//  ! 'phi' number in the ring in {1,4*nr}
+  jp = (jpll[face_num]*nr + jpt + 1 + kshift)/2;
+  if( jp>nl4 ) jp = jp - nl4;
+  if( jp<1 )   jp = jp + nl4;
+  phi = (jp - (kshift+1)*0.5) * (piover2 / nr);
+}
+
+// retourne le nom du fichier qui contient le spectre de puissance
+template<class T>
+void SphereGorski<T>::powfile(char filename[]) const 
+{
+  bool status = false;
+  for (int k=0; k< 128; k++)
+    {
+      if( powFile_[k] != ' ' )
+	{
+	  status = true;
+	  break;
 	}
-      }
-      theta = acos(z);
-      
-      //c     computes the phi coordinate on the sphere, in [0,2Pi]
-      //      jp = (jpll[face_num+1]*nr + jpt + 1 + kshift)/2;//  ! 'phi' number in the ring in {1,4*nr}
-      jp = (jpll[face_num]*nr + jpt + 1 + kshift)/2;
-      if( jp>nl4 ) jp = jp - nl4;
-      if( jp<1 )   jp = jp + nl4;
-
-      phi = (jp - (kshift+1)*0.5) * (piover2 / nr);
-
-}
-
-
-void SphereGorski::Pix2XY::pix2ang_nest(int nside, int ipix, double& theta, double& phi) const {
-  /*
-    c=======================================================================
-    subroutine pix2ang_nest(nside, ipix, theta, phi)
-    c=======================================================================
-    c     gives theta and phi corresponding to pixel ipix (NESTED) 
-    c     for a parameter nside
-    c=======================================================================
-  */
-  // tranlated from FORTRAN (Gorski) to C, by B. Revenu, revised Guy Le Meur
-  //  (16/12/98)
-    
-      int npix, npface, face_num;
-      int  ipf, ip_low, ip_trunc, ip_med, ip_hi;
-      int     ix, iy, jrt, jr, nr, jpt, jp, kshift, nl4;
-      double z, fn, fact1, fact2;
-      double piover2(Pi/2.);
-      int ns_max(8192);
-      
-      
-      // ! coordinate of the lowest corner of each face
-      int jrll[12]={2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4};//! in unit of nside
-      int jpll[12]={1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7};// ! in unit of nside/2
-      
-      if( nside<1 || nside>ns_max ) {
-	cout << "nside out of range" << endl;
-	exit(0);
-      }
-      npix = 12 * nside*nside;
-      if( ipix<0 || ipix>npix-1 ) {
-	cout << "ipix out of range" << endl;
-	exit(0);
-      }
-
-      fn = 1.*nside;
-      fact1 = 1./(3.*fn*fn);
-      fact2 = 2./(3.*fn);
-      nl4   = 4*nside;
-
-      //c     finds the face, and the number in the face
-      npface = nside*nside;
-
-      face_num = ipix/npface;//  ! face number in {0,11}
-      ipf = (int)fmod(ipix,npface);//  ! pixel number in the face {0,npface-1}
-
-      //c     finds the x,y on the face (starting from the lowest corner)
-      //c     from the pixel number
-      ip_low = (int)fmod(ipf,1024);//       ! content of the last 10 bits
-      ip_trunc =   ipf/1024 ;//       ! truncation of the last 10 bits
-      ip_med = (int)fmod(ip_trunc,1024);//  ! content of the next 10 bits
-      ip_hi  =     ip_trunc/1024   ;//! content of the high weight 10 bits
-
-      ix = 1024*pix2x_[ip_hi] + 32*pix2x_[ip_med] + pix2x_[ip_low];
-      iy = 1024*pix2y_[ip_hi] + 32*pix2y_[ip_med] + pix2y_[ip_low];
-
-      //c     transforms this in (horizontal, vertical) coordinates
-      jrt = ix + iy;//  ! 'vertical' in {0,2*(nside-1)}
-      jpt = ix - iy;//  ! 'horizontal' in {-nside+1,nside-1}
-
-      //c     computes the z coordinate on the sphere
-      //      jr =  jrll[face_num+1]*nside - jrt - 1;//   ! ring number in {1,4*nside-1}
-      jr =  jrll[face_num]*nside - jrt - 1;
-      nr = nside;//                  ! equatorial region (the most frequent)
-      z  = (2*nside-jr)*fact2;
-      kshift = (int)fmod(jr - nside, 2);
-      if( jr<nside ) { //then     ! north pole region
-         nr = jr;
-         z = 1. - nr*nr*fact1;
-         kshift = 0;
-      }
-      else {
-	if( jr>3*nside ) {// then ! south pole region
-         nr = nl4 - jr;
-         z = - 1. + nr*nr*fact1;
-         kshift = 0;
-	}
-      }
-      theta = acos(z);
-      
-      //c     computes the phi coordinate on the sphere, in [0,2Pi]
-      //      jp = (jpll[face_num+1]*nr + jpt + 1 + kshift)/2;//  ! 'phi' number in the ring in {1,4*nr}
-      jp = (jpll[face_num]*nr + jpt + 1 + kshift)/2;
-      if( jp>nl4 ) jp = jp - nl4;
-      if( jp<1 )   jp = jp + nl4;
-
-      phi = (jp - (kshift+1)*0.5) * (piover2 / nr);
-
-}
-
-
-
+    }
+  if ( status ) 
+    {
+      strcpy(filename,powFile_);
+    }
+  else
+    {
+      strcpy(filename,"no file");
+    }
+}
+
+template<class T>
+void SphereGorski<T>::getParafast(int_4& nlmax,int_4& nmmax,int_4& iseed,float& fwhm,float& quadr,float& cut) const
+{
+  nlmax= nlmax_;
+  nmmax= nmmax_;
+  iseed= iseed_;
+  fwhm = fwhm_;
+  quadr= quadrupole_;
+  cut  = sym_cut_deg_;
+}
+
+template<class T>
+void SphereGorski<T>::setParafast(int_4 nlmax,int_4 nmmax,int_4 iseed,float fwhm,float quadr,float cut,char* filename)
+{
+  nlmax_= nlmax;
+  nmmax_= nmmax;
+  iseed_= iseed;
+  fwhm_ = fwhm;
+  quadrupole_ = quadr;
+  sym_cut_deg_= cut; 
+  strcpy(powFile_,filename);
+}
+
+template <class T>
+void SphereGorski<T>::print(ostream& os) const
+{
+  if(mInfo_) os << "  DVList Info= " << *mInfo_ << endl;
+  //
+  os << " nSide_ = " << nSide_  << endl;
+  os << " nPix_   = " << nPix_   << endl;
+  os << " omeg_ = " << omeg_   << endl;
+
+  os << " contenu de pixels : ";
+  for(int i=0; i < nPix_; i++)
+    {
+      if(i%5 == 0) os << endl;
+      os <<  pixels_(i) <<", ";
+    }
+  os << endl;
+
+  os << endl;
+  const PIXELS_XY& PXY= PIXELS_XY::instance();
+
+  os << endl;  os << " contenu des tableaux conversions "<<endl;
+  for(int i=0; i < 5; i++)
+    {
+      os<<PXY.pix2x_(i)<<", "<<PXY.pix2y_(i)<<", "<<PXY.x2pix_(i)<<", "<<PXY.y2pix_(i)<<endl;
+    }
+  os << endl;
+
+  os << " les parametres des modules anafast et synfast " <<endl;
+  os << " nlmax, nmmax & iseed= " <<nlmax_<<", "<<nmmax_<<", "<<iseed_<<endl;
+  os << " fwhm, quadr & cut = "<<fwhm_<<", "<<quadrupole_<<", "<<sym_cut_deg_<<endl;
+  os << " powfile= " << powFile_<<endl;
+}
+
+//*******************************************************************
+// Class FIO_SphereGorski<T>
+//  Les objets delegues pour la gestion de persistance 
+//*******************************************************************
+
+template <class T>
+FIO_SphereGorski<T>::FIO_SphereGorski()
+{
+  dobj= new SphereGorski<T>;
+  ownobj= true;
+}
+
+template <class T>
+FIO_SphereGorski<T>::FIO_SphereGorski(string const& filename)
+{
+  dobj= new SphereGorski<T>;
+  ownobj= true;
+  Read(filename);
+}
+
+template <class T>
+FIO_SphereGorski<T>::FIO_SphereGorski(const SphereGorski<T>& obj)
+{
+  dobj= new SphereGorski<T>(obj);
+  ownobj= true;
+}
+
+template <class T>
+FIO_SphereGorski<T>::FIO_SphereGorski(SphereGorski<T>* obj)
+{
+  dobj= obj;
+  ownobj= false;
+}
+
+template <class T>
+FIO_SphereGorski<T>::~FIO_SphereGorski()
+{
+  if (ownobj && dobj) delete dobj;
+}
+
+template <class T>
+AnyDataObj* FIO_SphereGorski<T>::DataObj()
+{
+  return(dobj);
+}
+
+template <class T>
+void FIO_SphereGorski<T>::ReadSelf(PInPersist& is)
+{
+  cout << " FIO_SphereGorski:: ReadSelf " << endl;
+
+  if(dobj == NULL) 
+    {
+      dobj= new SphereGorski<T>;
+    }
+
+  // Pour savoir s'il y avait un DVList Info associe
+  char strg[256];
+  is.GetLine(strg, 255);
+  bool hadinfo= false;
+  if(strncmp(strg+strlen(strg)-7, "HasInfo", 7) == 0)  hadinfo= true;
+  if(hadinfo) 
+    {    // Lecture eventuelle du DVList Info
+      is >> dobj->Info(); 
+    }
+
+  int_4 nSide;
+  is.GetI4(nSide);
+  dobj->setSizeIndex(nSide);
+
+  int_4 nPix;
+  is.GetI4(nPix);
+  dobj->setNbPixels(nPix);
+
+  r_8 Omega;
+  is.GetR8(Omega);
+  dobj->setPixSolAngle(Omega);
+
+  T* pixels= new T[nPix];
+  PIOSReadArray(is, pixels, nPix);
+  dobj->setDataBlock(pixels, nPix);
+  delete [] pixels;
+
+  int_4 nlmax,nmmax,iseed;
+  is.GetI4(nlmax);
+  is.GetI4(nmmax);
+  is.GetI4(iseed);
+  
+  float fwhm,quadr,cut;
+  is.GetR4(fwhm);
+  is.GetR4(quadr);
+  is.GetR4(cut);
+
+  char powfl[128];
+  is.GetLine(powfl, 127);
+
+  dobj->setParafast(nlmax,nmmax,iseed,fwhm,quadr,cut,powfl);
+}
+
+template <class T>
+void FIO_SphereGorski<T>::WriteSelf(POutPersist& os) const
+{
+  cout << " FIO_SphereGorski:: WriteSelf " << endl;
+
+  if(dobj == NULL) 
+    {
+      cout << " WriteSelf:: dobj= null " << endl;
+      return;
+    }
+
+  char strg[256];
+  int_4 nSide= dobj->SizeIndex();
+  int_4 nPix = dobj->NbPixels();
+ 
+  if(dobj->ptrInfo()) 
+    {
+      sprintf(strg,"SphereGorski: NSide=%6d  NPix=%9d HasInfo",nSide,nPix);
+      os.PutLine(strg);
+      os << dobj->Info();
+    }
+  else 
+    { 
+      sprintf(strg,"SphereGorski: NSide=%6d  NPix=%9d ",nSide,nPix);
+      os.PutLine(strg);  
+    }
+
+  os.PutI4(nSide);
+  os.PutI4(nPix);
+  os.PutR8(dobj->PixSolAngle(0));
+
+  PIOSWriteArray(os,(dobj->getDataBlock())->Data(), nPix);
+
+  int_4 nlmax,nmmax,iseed;
+  float fwhm,quadr,cut;
+  dobj->getParafast(nlmax,nmmax,iseed,fwhm,quadr,cut);
+  os.PutI4(nlmax);
+  os.PutI4(nmmax);
+  os.PutI4(iseed);
+  os.PutR4(fwhm);
+  os.PutR4(quadr);
+  os.PutR4(cut);
+
+  char powfl[128];
+  dobj->powfile(powfl);
+  os.PutLine(powfl);
+}
+
+#ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template SphereGorski<double>
+#pragma define_template SphereGorski<float>
+#pragma define_template SphereGorski< complex<float> >
+#pragma define_template SphereGorski< complex<double> >
+#pragma define_template FIO_SphereGorski<double>
+#pragma define_template FIO_SphereGorski<float>
+#pragma define_template FIO_SphereGorski< complex<float> >
+#pragma define_template FIO_SphereGorski< complex<double> >
+#endif
+#if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+template class SphereGorski<double>;
+template class SphereGorski<float>;
+template class SphereGorski< complex<float> >;
+template class SphereGorski< complex<double> >;
+template class FIO_SphereGorski<double>;
+template class FIO_SphereGorski<float>;
+template class FIO_SphereGorski< complex<float> >;
+template class FIO_SphereGorski< complex<double> >;
+#endif
+
